package com.karneim.util.collection.regex;

public class InvalidExpression extends RuntimeException {

	private String expression;
	private String illegalToken;
	private int tokenPosition = -1;

	private static String makeMessage(String expression, String illegalToken, int tokenPosition) {
		try {
		String message = "Token \"" + illegalToken + "\" not allowed at this position: ";
			   message+= expression.substring( 0,tokenPosition );
			   message+= "\u0010" + illegalToken + "\u0011";
			   message+= expression.substring( tokenPosition+illegalToken.length() );
			return message;
		} catch ( Exception e) {
			System.out.println( e);
			System.out.println( "EXPRESSION="+expression+" TOKENPOS="+tokenPosition+ " ILLEGALTOKEN="+illegalToken);
		}
		throw new RuntimeException();
	}

	InvalidExpression() {};

	public InvalidExpression(String message) {super(message);}

	public InvalidExpression(String expression,String illegalToken,int tokenPosition) {
		super (InvalidExpression.makeMessage(expression,illegalToken,tokenPosition));
		this.expression = expression;
		this.illegalToken = illegalToken;
		this.tokenPosition = tokenPosition;
	}

	public String getExpression() {
		return this.expression;
	}

	public String getIllegalToken() {
		return this.illegalToken;
	}

	public int getIllegalTokenPosition() {
		return this.tokenPosition;
	}

}