package com.karneim.util.collection.regex;

/**
 * <p>Title: JRexPro</p>
 * <p>Description: regular Expression based on an (N)FSA</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Bro fr Softwarearchitektur   www.karneim.com</p>
 * @author unascribed
 * @version 1.0
 */
import com.karneim.util.collection.automaton.*;
import com.karneim.util.collection.set.*;

import java.util.*;
import java.lang.ref.SoftReference;

public class PAutomaton extends SAutomaton {
  private static final HashMap AUTOMATON_MAP = new HashMap();

  protected static final Automaton_Pattern get(String regEx) {
    synchronized(AUTOMATON_MAP) {
      final SoftReference reference = (SoftReference)AUTOMATON_MAP.get(regEx);

      if (reference!=null) {
        Automaton_Pattern automaton = (Automaton_Pattern)reference.get();
        if (automaton!=null) return automaton;
      }

      final Automaton_Pattern automaton = new Automaton_Pattern(regEx);

      AUTOMATON_MAP.put(regEx,new SoftReference(automaton));
      return automaton;
    }
  }

  public PAutomaton() {
  }

  protected PAutomaton(Automaton_Pattern automaton) {
    super(automaton);
  }

  protected AutomatonSet_String getAutomaton() {
    return this.automaton;
  }

  public PAutomaton(String regEx) {
    super(new Automaton_Pattern(regEx));
  }

  public void addAll(String regEx) {
    ((Automaton_Pattern)this.automaton).addAll(get(regEx));
  }

  public void retainAll(String regEx) {
    ((Automaton_Pattern)this.automaton).retainAll(get(regEx));
  }

  public void removeAll(String regEx) {
    ((Automaton_Pattern)this.automaton).removeAll(get(regEx));
  }

}